//
// XMM Science Analysis System
//
// Giuseppe Vacanti (cosine) 
// October 2000
//
#ifndef EMPROC_H
#define EMPROC_H


#include<EpicProc.h>
#include<Proc.h>

class EpicProcState;

class Emproc : public EpicProc {
public:
  Emproc(Xmm::Instrument);
  
private:
  
  void init_pimpl();
  
  void preProcessExposureHook(Proc::ScienceExposure&);
  //  void postProcessExposureHook(Proc::ScienceExposure&);
  
  //AI(26/04/2005): New method to handle with the exposure process.
  void processExposure(Proc::ScienceExposure&);

  //AI: New method that calls the new task: emeventsproj and embadpixfind
  void badPixelsSearch(const OdfSet *);

  void mergeIntermediateResults(Proc::ScienceExposure&);
  
  //AI: Set the values for emosimgcolnames and emosimgcoltypes
  void combineMergeEvents(ParameterInfo&);

  //AI: Call to ebadpixupdate task
  void badPixUpdate();

  // Screening
  bool makeFlareTs();
  void addFracExp(double timeBin);

  void tsToGTI();

  void testFlareGTI();

  void findFinalBadPixels(const OdfSet *);

  void frames(const OdfSet *);
  bool couldRunBadpixfindOn(const OdfSet *);
  virtual void preBadpixelsHook(const OdfSet *);
  void badpix(const OdfSet *);
  void events(const OdfSet *);
  
  //  void finalize(const OdfSet *);
  void finalizeHook(const OdfSet *);  
  void screenExposure(const Proc::ScienceExposure&);

  //  void postProcessExposure(Proc::ScienceExposure& exp);
  void combineHook(ParameterInfo&);
};

#endif
