//
// XMM Science Analysis System
//
//  Giuseppe Vacanti (cosine science & computing)
//  February 15, 2002
//
//   $Id: emproc.cc,v 1.2 2009/09/03 15:36:51 aibarra Exp $

#include <emproc.h>
#include <Emproc.h>
#include <cstdlib>

void emproc()
{
  PROC

  std::vector<std::string> p;
  ParameterInfo& pars = *Info::Task::current()->parameters();
  if(pars["selectinstruments"]->boolValue()){
    if(pars["emos1"]->boolValue())
      p.push_back("EMOS1");
    if(pars["emos2"]->boolValue())
      p.push_back("EMOS2");
  } else {
    p.push_back("EMOS1");
    p.push_back("EMOS2");
  }

  for(unsigned k=0; k<p.size(); ++k){

    errstr << "Processing data for instrument " << Xmm::toInstrument(p[k])
	   << Sas::message(Msg::Meta, Msg::Silent);
    /* AI gcc4 portin
     * no match for operator[] in p[k]
     * => rename variable Emproc p to Emproc emp
     */
    Emproc emp(Xmm::toInstrument(p[k]));
    emp.process();
  }
  ENDPROC
}
